//[h*r[*eϊ̍s
float4x4 gWVPMatrix;

//wĩItZbg
float2 gBgOffset;

//`̈̑傫
int gBgWidth;
int gBgHeight;

//eNX`
texture gTexture;
sampler gSampler = sampler_state {
	Texture = < gTexture >;
	MipFilter = NONE;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Clamp;	//iClanp0`1ȊO̍W̎ɒ[̃sNZЂ̂΂j
	AddressV = Clamp;
};

//ArGgl
float4 gAmbient = {0.0f,0.0f,0.0f,1.0f};

//{F
float4 gBaseColor = {0.0f, 1.0f, 0.0f, 1.0f};

//Cg
float3 dir = {1.0f / 5.1962f * 2.0f, 1.0f / 5.1962f * 2.0f, -5.0f / 5.1962f * 2.0f};

//----------------------//
//	_̓͏
//----------------------//
struct VS_INPUT
{
	float4 vPosition		: POSITION;		//_W
	float4 vNormal			: NORMAL;			//@xNg
	float2 vTexCoords	    : TEXCOORD0;	 //eNX`UV
};

//----------------------//
//	_̏o͏
//----------------------//
struct VS_OUTPUT
{
	float4 vPosition	 : POSITION;		//_W
	float4 Color		 : COLOR0;			//F
	float2 vTexCoords	 : TEXCOORD0;	 //eNX`UV
};

//----------------------//
//	sNZ̓͏
//----------------------//
struct PS_INPUT
{
	float4 Color		 : COLOR0;		 //ft[YF
	float2 vTexCoords	 : TEXCOORD0;	//eNX`UV
};

//----------------------//
//	sNZ̏o͏
//----------------------//
struct PS_OUTPUT
{
	float4 vColor			 : COLOR0;		 //ŏIIȏo͐F
};

//------------------------//
// _VF[_[
//------------------------//
VS_OUTPUT VSGrass(VS_INPUT v)
{
	VS_OUTPUT o = (VS_OUTPUT)0;

	//Wϊ
	o.vPosition = mul(v.vPosition , gWVPMatrix);

	//wỉf荞
	float4 dp;
	dp.z = o.vPosition.z;
	dp.x = (o.vPosition.x * (1.0f - v.vPosition.z / 2.0f)) * gBgWidth / 2.0f + o.vPosition.w * gBgWidth / 2.0f;
	dp.y = (o.vPosition.y * (1.0f - v.vPosition.z / 2.0f)) * (-gBgHeight / 2.0f) + o.vPosition.w * gBgHeight / 2.0f;
	dp.w = o.vPosition.w;
	dp.x = dp.x / dp.w;
	dp.y = dp.y / dp.w;
	o.vTexCoords.x = ((int)(dp.x - gBgOffset.x + 1024*3) % 1024) / 1024.0f;
	o.vTexCoords.y = ((int)(dp.y - gBgOffset.y + 1024*3) % 1024) / 1024.0f;

	// @̃`FbN
    float3 N = normalize( v.vNormal );
	o.Color.rgb = gBaseColor.rgb * (abs(dot(-dir, N) * 3.0f) + max((dot(-dir, N) - 0.7f) + 0.7f, 0) * 0.7f) + gAmbient.rgb;

	// At@͂̂܂܏o
	o.Color.a = gBaseColor.a;
	
	return o;
}

//------------------------//
// sNZVF[_[
//------------------------//
PS_OUTPUT PSBaseColor(PS_INPUT p)
{
	PS_OUTPUT o = (PS_OUTPUT)0;

	o.vColor = p.Color * (tex2D(gSampler, p.vTexCoords) + 0.8f);

	//o.vColor = tex2D(gSampler, p.vTexCoords);

	return o;
}


//------------------------//
// eNjbN̋Lq
//------------------------//
technique t1
{
	pass P0
	{
		VertexShader = compile vs_2_0 VSGrass();
		PixelShader	= compile ps_2_0 PSBaseColor();
	}
}